// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: build/bazel/remote/asset/v1/remote_asset.proto
// Original file comments:
// Copyright 2020 The Bazel Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_build_2fbazel_2fremote_2fasset_2fv1_2fremote_5fasset_2eproto__INCLUDED
#define GRPC_build_2fbazel_2fremote_2fasset_2fv1_2fremote_5fasset_2eproto__INCLUDED

#include "build/bazel/remote/asset/v1/remote_asset.pb.h"

#include <functional>
#include <grpcpp/impl/codegen/async_generic_service.h>
#include <grpcpp/impl/codegen/async_stream.h>
#include <grpcpp/impl/codegen/async_unary_call.h>
#include <grpcpp/impl/codegen/client_callback.h>
#include <grpcpp/impl/codegen/client_context.h>
#include <grpcpp/impl/codegen/completion_queue.h>
#include <grpcpp/impl/codegen/message_allocator.h>
#include <grpcpp/impl/codegen/method_handler.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/server_callback.h>
#include <grpcpp/impl/codegen/server_callback_handlers.h>
#include <grpcpp/impl/codegen/server_context.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace build {
namespace bazel {
namespace remote {
namespace asset {
namespace v1 {

// The Fetch service resolves or fetches assets referenced by URI and
// Qualifiers, returning a Digest for the content in 
// [ContentAddressableStorage][build.bazel.remote.execution.v2.ContentAddressableStorage].
//
// As with other services in the Remote Execution API, any call may return an
// error with a [RetryInfo][google.rpc.RetryInfo] error detail providing
// information about when the client should retry the request; clients SHOULD
// respect the information provided.
class Fetch final {
 public:
  static constexpr char const* service_full_name() {
    return "build.bazel.remote.asset.v1.Fetch";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Resolve or fetch referenced assets, making them available to the caller and
    // other consumers in the [ContentAddressableStorage][build.bazel.remote.execution.v2.ContentAddressableStorage].
    //
    // Servers *MAY* fetch content that they do not already have cached, for any
    // URLs they support.
    //
    // Servers *SHOULD* ensure that referenced files are present in the CAS at the
    // time of the response, and (if supported) that they will remain available
    // for a reasonable period of time. The lifetimes of the referenced blobs *SHOULD*
    // be increased if necessary and applicable.
    // In the event that a client receives a reference to content that is no
    // longer present, it *MAY* re-issue the request with
    // `oldest_content_accepted` set to a more recent timestamp than the original
    // attempt, to induce a re-fetch from origin.
    //
    // Servers *MAY* cache fetched content and reuse it for subsequent requests,
    // subject to `oldest_content_accepted`.
    //
    // Servers *MAY* support the complementary [Push][build.bazel.remote.asset.v1.Push]
    // API and allow content to be directly inserted for use in future fetch
    // responses.
    //
    // Servers *MUST* ensure Fetch'd content matches all the specified
    // qualifiers except in the case of previously Push'd resources, for which
    // the server *MAY* trust the pushing client to have set the qualifiers
    // correctly, without validation.
    //
    // Servers not implementing the complementary [Push][build.bazel.remote.asset.v1.Push]
    // API *MUST* reject requests containing qualifiers it does not support.
    //
    // Servers *MAY* transform assets as part of the fetch. For example a
    // tarball fetched by [FetchDirectory][build.bazel.remote.asset.v1.Fetch.FetchDirectory]
    // might be unpacked, or a Git repository
    // fetched by [FetchBlob][build.bazel.remote.asset.v1.Fetch.FetchBlob]
    // might be passed through `git-archive`.
    //
    // Errors handling the requested assets will be returned as gRPC Status errors
    // here; errors outside the server's control will be returned inline in the
    // `status` field of the response (see comment there for details).
    // The possible RPC errors include:
    // * `INVALID_ARGUMENT`: One or more arguments were invalid, such as a
    //   qualifier that is not supported by the server.
    // * `RESOURCE_EXHAUSTED`: There is insufficient quota of some resource to
    //   perform the requested operation. The client may retry after a delay.
    // * `UNAVAILABLE`: Due to a transient condition the operation could not be
    //   completed. The client should retry.
    // * `INTERNAL`: An internal error occurred while performing the operation.
    //   The client should retry.
    // * `DEADLINE_EXCEEDED`: The fetch could not be completed within the given
    //   RPC deadline. The client should retry for at least as long as the value
    //   provided in `timeout` field of the request.
    //
    // In the case of unsupported qualifiers, the server *SHOULD* additionally
    // send a [BadRequest][google.rpc.BadRequest] error detail where, for each
    // unsupported qualifier, there is a `FieldViolation` with a `field` of
    // `qualifiers.name` and a `description` of `"{qualifier}" not supported`
    // indicating the name of the unsupported qualifier.
    virtual ::grpc::Status FetchBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest& request, ::build::bazel::remote::asset::v1::FetchBlobResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::FetchBlobResponse>> AsyncFetchBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::FetchBlobResponse>>(AsyncFetchBlobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::FetchBlobResponse>> PrepareAsyncFetchBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::FetchBlobResponse>>(PrepareAsyncFetchBlobRaw(context, request, cq));
    }
    virtual ::grpc::Status FetchDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest& request, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>> AsyncFetchDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>>(AsyncFetchDirectoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>> PrepareAsyncFetchDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>>(PrepareAsyncFetchDirectoryRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Resolve or fetch referenced assets, making them available to the caller and
      // other consumers in the [ContentAddressableStorage][build.bazel.remote.execution.v2.ContentAddressableStorage].
      //
      // Servers *MAY* fetch content that they do not already have cached, for any
      // URLs they support.
      //
      // Servers *SHOULD* ensure that referenced files are present in the CAS at the
      // time of the response, and (if supported) that they will remain available
      // for a reasonable period of time. The lifetimes of the referenced blobs *SHOULD*
      // be increased if necessary and applicable.
      // In the event that a client receives a reference to content that is no
      // longer present, it *MAY* re-issue the request with
      // `oldest_content_accepted` set to a more recent timestamp than the original
      // attempt, to induce a re-fetch from origin.
      //
      // Servers *MAY* cache fetched content and reuse it for subsequent requests,
      // subject to `oldest_content_accepted`.
      //
      // Servers *MAY* support the complementary [Push][build.bazel.remote.asset.v1.Push]
      // API and allow content to be directly inserted for use in future fetch
      // responses.
      //
      // Servers *MUST* ensure Fetch'd content matches all the specified
      // qualifiers except in the case of previously Push'd resources, for which
      // the server *MAY* trust the pushing client to have set the qualifiers
      // correctly, without validation.
      //
      // Servers not implementing the complementary [Push][build.bazel.remote.asset.v1.Push]
      // API *MUST* reject requests containing qualifiers it does not support.
      //
      // Servers *MAY* transform assets as part of the fetch. For example a
      // tarball fetched by [FetchDirectory][build.bazel.remote.asset.v1.Fetch.FetchDirectory]
      // might be unpacked, or a Git repository
      // fetched by [FetchBlob][build.bazel.remote.asset.v1.Fetch.FetchBlob]
      // might be passed through `git-archive`.
      //
      // Errors handling the requested assets will be returned as gRPC Status errors
      // here; errors outside the server's control will be returned inline in the
      // `status` field of the response (see comment there for details).
      // The possible RPC errors include:
      // * `INVALID_ARGUMENT`: One or more arguments were invalid, such as a
      //   qualifier that is not supported by the server.
      // * `RESOURCE_EXHAUSTED`: There is insufficient quota of some resource to
      //   perform the requested operation. The client may retry after a delay.
      // * `UNAVAILABLE`: Due to a transient condition the operation could not be
      //   completed. The client should retry.
      // * `INTERNAL`: An internal error occurred while performing the operation.
      //   The client should retry.
      // * `DEADLINE_EXCEEDED`: The fetch could not be completed within the given
      //   RPC deadline. The client should retry for at least as long as the value
      //   provided in `timeout` field of the request.
      //
      // In the case of unsupported qualifiers, the server *SHOULD* additionally
      // send a [BadRequest][google.rpc.BadRequest] error detail where, for each
      // unsupported qualifier, there is a `FieldViolation` with a `field` of
      // `qualifiers.name` and a `description` of `"{qualifier}" not supported`
      // indicating the name of the unsupported qualifier.
      virtual void FetchBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest* request, ::build::bazel::remote::asset::v1::FetchBlobResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void FetchBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest* request, ::build::bazel::remote::asset::v1::FetchBlobResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      virtual void FetchDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* request, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void FetchDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* request, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::FetchBlobResponse>* AsyncFetchBlobRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::FetchBlobResponse>* PrepareAsyncFetchBlobRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>* AsyncFetchDirectoryRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>* PrepareAsyncFetchDirectoryRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status FetchBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest& request, ::build::bazel::remote::asset::v1::FetchBlobResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::FetchBlobResponse>> AsyncFetchBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::FetchBlobResponse>>(AsyncFetchBlobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::FetchBlobResponse>> PrepareAsyncFetchBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::FetchBlobResponse>>(PrepareAsyncFetchBlobRaw(context, request, cq));
    }
    ::grpc::Status FetchDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest& request, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>> AsyncFetchDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>>(AsyncFetchDirectoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>> PrepareAsyncFetchDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>>(PrepareAsyncFetchDirectoryRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void FetchBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest* request, ::build::bazel::remote::asset::v1::FetchBlobResponse* response, std::function<void(::grpc::Status)>) override;
      void FetchBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest* request, ::build::bazel::remote::asset::v1::FetchBlobResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void FetchDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* request, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* response, std::function<void(::grpc::Status)>) override;
      void FetchDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* request, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::FetchBlobResponse>* AsyncFetchBlobRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::FetchBlobResponse>* PrepareAsyncFetchBlobRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>* AsyncFetchDirectoryRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>* PrepareAsyncFetchDirectoryRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_FetchBlob_;
    const ::grpc::internal::RpcMethod rpcmethod_FetchDirectory_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Resolve or fetch referenced assets, making them available to the caller and
    // other consumers in the [ContentAddressableStorage][build.bazel.remote.execution.v2.ContentAddressableStorage].
    //
    // Servers *MAY* fetch content that they do not already have cached, for any
    // URLs they support.
    //
    // Servers *SHOULD* ensure that referenced files are present in the CAS at the
    // time of the response, and (if supported) that they will remain available
    // for a reasonable period of time. The lifetimes of the referenced blobs *SHOULD*
    // be increased if necessary and applicable.
    // In the event that a client receives a reference to content that is no
    // longer present, it *MAY* re-issue the request with
    // `oldest_content_accepted` set to a more recent timestamp than the original
    // attempt, to induce a re-fetch from origin.
    //
    // Servers *MAY* cache fetched content and reuse it for subsequent requests,
    // subject to `oldest_content_accepted`.
    //
    // Servers *MAY* support the complementary [Push][build.bazel.remote.asset.v1.Push]
    // API and allow content to be directly inserted for use in future fetch
    // responses.
    //
    // Servers *MUST* ensure Fetch'd content matches all the specified
    // qualifiers except in the case of previously Push'd resources, for which
    // the server *MAY* trust the pushing client to have set the qualifiers
    // correctly, without validation.
    //
    // Servers not implementing the complementary [Push][build.bazel.remote.asset.v1.Push]
    // API *MUST* reject requests containing qualifiers it does not support.
    //
    // Servers *MAY* transform assets as part of the fetch. For example a
    // tarball fetched by [FetchDirectory][build.bazel.remote.asset.v1.Fetch.FetchDirectory]
    // might be unpacked, or a Git repository
    // fetched by [FetchBlob][build.bazel.remote.asset.v1.Fetch.FetchBlob]
    // might be passed through `git-archive`.
    //
    // Errors handling the requested assets will be returned as gRPC Status errors
    // here; errors outside the server's control will be returned inline in the
    // `status` field of the response (see comment there for details).
    // The possible RPC errors include:
    // * `INVALID_ARGUMENT`: One or more arguments were invalid, such as a
    //   qualifier that is not supported by the server.
    // * `RESOURCE_EXHAUSTED`: There is insufficient quota of some resource to
    //   perform the requested operation. The client may retry after a delay.
    // * `UNAVAILABLE`: Due to a transient condition the operation could not be
    //   completed. The client should retry.
    // * `INTERNAL`: An internal error occurred while performing the operation.
    //   The client should retry.
    // * `DEADLINE_EXCEEDED`: The fetch could not be completed within the given
    //   RPC deadline. The client should retry for at least as long as the value
    //   provided in `timeout` field of the request.
    //
    // In the case of unsupported qualifiers, the server *SHOULD* additionally
    // send a [BadRequest][google.rpc.BadRequest] error detail where, for each
    // unsupported qualifier, there is a `FieldViolation` with a `field` of
    // `qualifiers.name` and a `description` of `"{qualifier}" not supported`
    // indicating the name of the unsupported qualifier.
    virtual ::grpc::Status FetchBlob(::grpc::ServerContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest* request, ::build::bazel::remote::asset::v1::FetchBlobResponse* response);
    virtual ::grpc::Status FetchDirectory(::grpc::ServerContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* request, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_FetchBlob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_FetchBlob() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_FetchBlob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchBlob(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchBlobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFetchBlob(::grpc::ServerContext* context, ::build::bazel::remote::asset::v1::FetchBlobRequest* request, ::grpc::ServerAsyncResponseWriter< ::build::bazel::remote::asset::v1::FetchBlobResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_FetchDirectory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_FetchDirectory() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_FetchDirectory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchDirectory(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFetchDirectory(::grpc::ServerContext* context, ::build::bazel::remote::asset::v1::FetchDirectoryRequest* request, ::grpc::ServerAsyncResponseWriter< ::build::bazel::remote::asset::v1::FetchDirectoryResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_FetchBlob<WithAsyncMethod_FetchDirectory<Service > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_FetchBlob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_FetchBlob() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::build::bazel::remote::asset::v1::FetchBlobRequest, ::build::bazel::remote::asset::v1::FetchBlobResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::build::bazel::remote::asset::v1::FetchBlobRequest* request, ::build::bazel::remote::asset::v1::FetchBlobResponse* response) { return this->FetchBlob(context, request, response); }));}
    void SetMessageAllocatorFor_FetchBlob(
        ::grpc::MessageAllocator< ::build::bazel::remote::asset::v1::FetchBlobRequest, ::build::bazel::remote::asset::v1::FetchBlobResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::build::bazel::remote::asset::v1::FetchBlobRequest, ::build::bazel::remote::asset::v1::FetchBlobResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_FetchBlob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchBlob(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchBlobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FetchBlob(
      ::grpc::CallbackServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchBlobResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_FetchDirectory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_FetchDirectory() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::build::bazel::remote::asset::v1::FetchDirectoryRequest, ::build::bazel::remote::asset::v1::FetchDirectoryResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* request, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* response) { return this->FetchDirectory(context, request, response); }));}
    void SetMessageAllocatorFor_FetchDirectory(
        ::grpc::MessageAllocator< ::build::bazel::remote::asset::v1::FetchDirectoryRequest, ::build::bazel::remote::asset::v1::FetchDirectoryResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::build::bazel::remote::asset::v1::FetchDirectoryRequest, ::build::bazel::remote::asset::v1::FetchDirectoryResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_FetchDirectory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchDirectory(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FetchDirectory(
      ::grpc::CallbackServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_FetchBlob<WithCallbackMethod_FetchDirectory<Service > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_FetchBlob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_FetchBlob() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_FetchBlob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchBlob(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchBlobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_FetchDirectory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_FetchDirectory() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_FetchDirectory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchDirectory(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_FetchBlob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_FetchBlob() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_FetchBlob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchBlob(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchBlobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFetchBlob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_FetchDirectory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_FetchDirectory() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_FetchDirectory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchDirectory(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFetchDirectory(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_FetchBlob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_FetchBlob() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->FetchBlob(context, request, response); }));
    }
    ~WithRawCallbackMethod_FetchBlob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchBlob(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchBlobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FetchBlob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_FetchDirectory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_FetchDirectory() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->FetchDirectory(context, request, response); }));
    }
    ~WithRawCallbackMethod_FetchDirectory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchDirectory(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FetchDirectory(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_FetchBlob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_FetchBlob() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::build::bazel::remote::asset::v1::FetchBlobRequest, ::build::bazel::remote::asset::v1::FetchBlobResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::build::bazel::remote::asset::v1::FetchBlobRequest, ::build::bazel::remote::asset::v1::FetchBlobResponse>* streamer) {
                       return this->StreamedFetchBlob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_FetchBlob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status FetchBlob(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchBlobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedFetchBlob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::build::bazel::remote::asset::v1::FetchBlobRequest,::build::bazel::remote::asset::v1::FetchBlobResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_FetchDirectory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_FetchDirectory() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::build::bazel::remote::asset::v1::FetchDirectoryRequest, ::build::bazel::remote::asset::v1::FetchDirectoryResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::build::bazel::remote::asset::v1::FetchDirectoryRequest, ::build::bazel::remote::asset::v1::FetchDirectoryResponse>* streamer) {
                       return this->StreamedFetchDirectory(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_FetchDirectory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status FetchDirectory(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::FetchDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::FetchDirectoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedFetchDirectory(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::build::bazel::remote::asset::v1::FetchDirectoryRequest,::build::bazel::remote::asset::v1::FetchDirectoryResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_FetchBlob<WithStreamedUnaryMethod_FetchDirectory<Service > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_FetchBlob<WithStreamedUnaryMethod_FetchDirectory<Service > > StreamedService;
};

// The Push service is complementary to the Fetch, and allows for
// associating contents of URLs to be returned in future Fetch API calls.
//
// As with other services in the Remote Execution API, any call may return an
// error with a [RetryInfo][google.rpc.RetryInfo] error detail providing
// information about when the client should retry the request; clients SHOULD
// respect the information provided.
class Push final {
 public:
  static constexpr char const* service_full_name() {
    return "build.bazel.remote.asset.v1.Push";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // These APIs associate the identifying information of a resource, as
    // indicated by URI and optionally Qualifiers, with content available in the
    // CAS. For example, associating a repository url and a commit id with a
    // Directory Digest.
    //
    // Servers *SHOULD* only allow trusted clients to associate content, and *MAY*
    // only allow certain URIs to be pushed.
    //
    // Clients *MUST* ensure associated content is available in CAS prior to
    // pushing.
    //
    // Clients *MUST* ensure the Qualifiers listed correctly match the contents,
    // and Servers *MAY* trust these values without validation.
    // Fetch servers *MAY* require exact match of all qualifiers when returning
    // content previously pushed, or allow fetching content with only a subset of
    // the qualifiers specified on Push.
    //
    // Clients can specify expiration information that the server *SHOULD*
    // respect. Subsequent requests can be used to alter the expiration time.
    //
    // A minimal compliant Fetch implementation may support only Push'd content
    // and return `NOT_FOUND` for any resource that was not pushed first.
    // Alternatively, a compliant implementation may choose to not support Push
    // and only return resources that can be Fetch'd from origin.
    //
    // Errors will be returned as gRPC Status errors.
    // The possible RPC errors include:
    // * `INVALID_ARGUMENT`: One or more arguments to the RPC were invalid.
    // * `RESOURCE_EXHAUSTED`: There is insufficient quota of some resource to
    //   perform the requested operation. The client may retry after a delay.
    // * `UNAVAILABLE`: Due to a transient condition the operation could not be
    //   completed. The client should retry.
    // * `INTERNAL`: An internal error occurred while performing the operation.
    //   The client should retry.
    virtual ::grpc::Status PushBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest& request, ::build::bazel::remote::asset::v1::PushBlobResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::PushBlobResponse>> AsyncPushBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::PushBlobResponse>>(AsyncPushBlobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::PushBlobResponse>> PrepareAsyncPushBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::PushBlobResponse>>(PrepareAsyncPushBlobRaw(context, request, cq));
    }
    virtual ::grpc::Status PushDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest& request, ::build::bazel::remote::asset::v1::PushDirectoryResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::PushDirectoryResponse>> AsyncPushDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::PushDirectoryResponse>>(AsyncPushDirectoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::PushDirectoryResponse>> PrepareAsyncPushDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::PushDirectoryResponse>>(PrepareAsyncPushDirectoryRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // These APIs associate the identifying information of a resource, as
      // indicated by URI and optionally Qualifiers, with content available in the
      // CAS. For example, associating a repository url and a commit id with a
      // Directory Digest.
      //
      // Servers *SHOULD* only allow trusted clients to associate content, and *MAY*
      // only allow certain URIs to be pushed.
      //
      // Clients *MUST* ensure associated content is available in CAS prior to
      // pushing.
      //
      // Clients *MUST* ensure the Qualifiers listed correctly match the contents,
      // and Servers *MAY* trust these values without validation.
      // Fetch servers *MAY* require exact match of all qualifiers when returning
      // content previously pushed, or allow fetching content with only a subset of
      // the qualifiers specified on Push.
      //
      // Clients can specify expiration information that the server *SHOULD*
      // respect. Subsequent requests can be used to alter the expiration time.
      //
      // A minimal compliant Fetch implementation may support only Push'd content
      // and return `NOT_FOUND` for any resource that was not pushed first.
      // Alternatively, a compliant implementation may choose to not support Push
      // and only return resources that can be Fetch'd from origin.
      //
      // Errors will be returned as gRPC Status errors.
      // The possible RPC errors include:
      // * `INVALID_ARGUMENT`: One or more arguments to the RPC were invalid.
      // * `RESOURCE_EXHAUSTED`: There is insufficient quota of some resource to
      //   perform the requested operation. The client may retry after a delay.
      // * `UNAVAILABLE`: Due to a transient condition the operation could not be
      //   completed. The client should retry.
      // * `INTERNAL`: An internal error occurred while performing the operation.
      //   The client should retry.
      virtual void PushBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest* request, ::build::bazel::remote::asset::v1::PushBlobResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PushBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest* request, ::build::bazel::remote::asset::v1::PushBlobResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      virtual void PushDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* request, ::build::bazel::remote::asset::v1::PushDirectoryResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PushDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* request, ::build::bazel::remote::asset::v1::PushDirectoryResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::PushBlobResponse>* AsyncPushBlobRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::PushBlobResponse>* PrepareAsyncPushBlobRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::PushDirectoryResponse>* AsyncPushDirectoryRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::asset::v1::PushDirectoryResponse>* PrepareAsyncPushDirectoryRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status PushBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest& request, ::build::bazel::remote::asset::v1::PushBlobResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::PushBlobResponse>> AsyncPushBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::PushBlobResponse>>(AsyncPushBlobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::PushBlobResponse>> PrepareAsyncPushBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::PushBlobResponse>>(PrepareAsyncPushBlobRaw(context, request, cq));
    }
    ::grpc::Status PushDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest& request, ::build::bazel::remote::asset::v1::PushDirectoryResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::PushDirectoryResponse>> AsyncPushDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::PushDirectoryResponse>>(AsyncPushDirectoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::PushDirectoryResponse>> PrepareAsyncPushDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::PushDirectoryResponse>>(PrepareAsyncPushDirectoryRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void PushBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest* request, ::build::bazel::remote::asset::v1::PushBlobResponse* response, std::function<void(::grpc::Status)>) override;
      void PushBlob(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest* request, ::build::bazel::remote::asset::v1::PushBlobResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void PushDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* request, ::build::bazel::remote::asset::v1::PushDirectoryResponse* response, std::function<void(::grpc::Status)>) override;
      void PushDirectory(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* request, ::build::bazel::remote::asset::v1::PushDirectoryResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::PushBlobResponse>* AsyncPushBlobRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::PushBlobResponse>* PrepareAsyncPushBlobRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::PushDirectoryResponse>* AsyncPushDirectoryRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::asset::v1::PushDirectoryResponse>* PrepareAsyncPushDirectoryRaw(::grpc::ClientContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_PushBlob_;
    const ::grpc::internal::RpcMethod rpcmethod_PushDirectory_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // These APIs associate the identifying information of a resource, as
    // indicated by URI and optionally Qualifiers, with content available in the
    // CAS. For example, associating a repository url and a commit id with a
    // Directory Digest.
    //
    // Servers *SHOULD* only allow trusted clients to associate content, and *MAY*
    // only allow certain URIs to be pushed.
    //
    // Clients *MUST* ensure associated content is available in CAS prior to
    // pushing.
    //
    // Clients *MUST* ensure the Qualifiers listed correctly match the contents,
    // and Servers *MAY* trust these values without validation.
    // Fetch servers *MAY* require exact match of all qualifiers when returning
    // content previously pushed, or allow fetching content with only a subset of
    // the qualifiers specified on Push.
    //
    // Clients can specify expiration information that the server *SHOULD*
    // respect. Subsequent requests can be used to alter the expiration time.
    //
    // A minimal compliant Fetch implementation may support only Push'd content
    // and return `NOT_FOUND` for any resource that was not pushed first.
    // Alternatively, a compliant implementation may choose to not support Push
    // and only return resources that can be Fetch'd from origin.
    //
    // Errors will be returned as gRPC Status errors.
    // The possible RPC errors include:
    // * `INVALID_ARGUMENT`: One or more arguments to the RPC were invalid.
    // * `RESOURCE_EXHAUSTED`: There is insufficient quota of some resource to
    //   perform the requested operation. The client may retry after a delay.
    // * `UNAVAILABLE`: Due to a transient condition the operation could not be
    //   completed. The client should retry.
    // * `INTERNAL`: An internal error occurred while performing the operation.
    //   The client should retry.
    virtual ::grpc::Status PushBlob(::grpc::ServerContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest* request, ::build::bazel::remote::asset::v1::PushBlobResponse* response);
    virtual ::grpc::Status PushDirectory(::grpc::ServerContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* request, ::build::bazel::remote::asset::v1::PushDirectoryResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_PushBlob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PushBlob() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_PushBlob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PushBlob(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::PushBlobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPushBlob(::grpc::ServerContext* context, ::build::bazel::remote::asset::v1::PushBlobRequest* request, ::grpc::ServerAsyncResponseWriter< ::build::bazel::remote::asset::v1::PushBlobResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_PushDirectory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PushDirectory() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_PushDirectory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PushDirectory(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::PushDirectoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPushDirectory(::grpc::ServerContext* context, ::build::bazel::remote::asset::v1::PushDirectoryRequest* request, ::grpc::ServerAsyncResponseWriter< ::build::bazel::remote::asset::v1::PushDirectoryResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_PushBlob<WithAsyncMethod_PushDirectory<Service > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_PushBlob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PushBlob() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::build::bazel::remote::asset::v1::PushBlobRequest, ::build::bazel::remote::asset::v1::PushBlobResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::build::bazel::remote::asset::v1::PushBlobRequest* request, ::build::bazel::remote::asset::v1::PushBlobResponse* response) { return this->PushBlob(context, request, response); }));}
    void SetMessageAllocatorFor_PushBlob(
        ::grpc::MessageAllocator< ::build::bazel::remote::asset::v1::PushBlobRequest, ::build::bazel::remote::asset::v1::PushBlobResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::build::bazel::remote::asset::v1::PushBlobRequest, ::build::bazel::remote::asset::v1::PushBlobResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PushBlob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PushBlob(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::PushBlobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PushBlob(
      ::grpc::CallbackServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::PushBlobResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_PushDirectory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PushDirectory() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::build::bazel::remote::asset::v1::PushDirectoryRequest, ::build::bazel::remote::asset::v1::PushDirectoryResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* request, ::build::bazel::remote::asset::v1::PushDirectoryResponse* response) { return this->PushDirectory(context, request, response); }));}
    void SetMessageAllocatorFor_PushDirectory(
        ::grpc::MessageAllocator< ::build::bazel::remote::asset::v1::PushDirectoryRequest, ::build::bazel::remote::asset::v1::PushDirectoryResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::build::bazel::remote::asset::v1::PushDirectoryRequest, ::build::bazel::remote::asset::v1::PushDirectoryResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PushDirectory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PushDirectory(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::PushDirectoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PushDirectory(
      ::grpc::CallbackServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::PushDirectoryResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_PushBlob<WithCallbackMethod_PushDirectory<Service > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_PushBlob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PushBlob() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_PushBlob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PushBlob(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::PushBlobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_PushDirectory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PushDirectory() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_PushDirectory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PushDirectory(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::PushDirectoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_PushBlob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PushBlob() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_PushBlob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PushBlob(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::PushBlobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPushBlob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_PushDirectory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PushDirectory() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_PushDirectory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PushDirectory(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::PushDirectoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPushDirectory(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PushBlob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PushBlob() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PushBlob(context, request, response); }));
    }
    ~WithRawCallbackMethod_PushBlob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PushBlob(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::PushBlobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PushBlob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PushDirectory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PushDirectory() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PushDirectory(context, request, response); }));
    }
    ~WithRawCallbackMethod_PushDirectory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PushDirectory(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::PushDirectoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PushDirectory(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PushBlob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PushBlob() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::build::bazel::remote::asset::v1::PushBlobRequest, ::build::bazel::remote::asset::v1::PushBlobResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::build::bazel::remote::asset::v1::PushBlobRequest, ::build::bazel::remote::asset::v1::PushBlobResponse>* streamer) {
                       return this->StreamedPushBlob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PushBlob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PushBlob(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushBlobRequest* /*request*/, ::build::bazel::remote::asset::v1::PushBlobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPushBlob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::build::bazel::remote::asset::v1::PushBlobRequest,::build::bazel::remote::asset::v1::PushBlobResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PushDirectory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PushDirectory() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::build::bazel::remote::asset::v1::PushDirectoryRequest, ::build::bazel::remote::asset::v1::PushDirectoryResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::build::bazel::remote::asset::v1::PushDirectoryRequest, ::build::bazel::remote::asset::v1::PushDirectoryResponse>* streamer) {
                       return this->StreamedPushDirectory(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PushDirectory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PushDirectory(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::asset::v1::PushDirectoryRequest* /*request*/, ::build::bazel::remote::asset::v1::PushDirectoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPushDirectory(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::build::bazel::remote::asset::v1::PushDirectoryRequest,::build::bazel::remote::asset::v1::PushDirectoryResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_PushBlob<WithStreamedUnaryMethod_PushDirectory<Service > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_PushBlob<WithStreamedUnaryMethod_PushDirectory<Service > > StreamedService;
};

}  // namespace v1
}  // namespace asset
}  // namespace remote
}  // namespace bazel
}  // namespace build


#endif  // GRPC_build_2fbazel_2fremote_2fasset_2fv1_2fremote_5fasset_2eproto__INCLUDED
