// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: build/bazel/remote/logstream/v1/remote_logstream.proto
// Original file comments:
// Copyright 2020 The Bazel Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Log Stream API
//
#ifndef GRPC_build_2fbazel_2fremote_2flogstream_2fv1_2fremote_5flogstream_2eproto__INCLUDED
#define GRPC_build_2fbazel_2fremote_2flogstream_2fv1_2fremote_5flogstream_2eproto__INCLUDED

#include "build/bazel/remote/logstream/v1/remote_logstream.pb.h"

#include <functional>
#include <grpcpp/impl/codegen/async_generic_service.h>
#include <grpcpp/impl/codegen/async_stream.h>
#include <grpcpp/impl/codegen/async_unary_call.h>
#include <grpcpp/impl/codegen/client_callback.h>
#include <grpcpp/impl/codegen/client_context.h>
#include <grpcpp/impl/codegen/completion_queue.h>
#include <grpcpp/impl/codegen/message_allocator.h>
#include <grpcpp/impl/codegen/method_handler.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/server_callback.h>
#include <grpcpp/impl/codegen/server_callback_handlers.h>
#include <grpcpp/impl/codegen/server_context.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace build {
namespace bazel {
namespace remote {
namespace logstream {
namespace v1 {

// #### Introduction
//
// The Log Stream API manages LogStream resources which are used to stream
// writes and reads of an ordered sequence of bytes of unknown eventual length.
//
// Note that this is an API Interface and not an API Service, per the definitons
// at: https://cloud.google.com/apis/design/glossary
//
// Log Stream API supports the reading of unfinalized LogStreams either by
// seeking or in "tail" mode, for example by end-users browsing to a build
// result UI interested in seeing logs from a build action as soon as they are
// (or as they become) available.
//
// Reads and Writes of LogStreams are done via the Byte Stream API:
// https://cloud.google.com/dataproc/docs/reference/rpc/google.bytestream
// https://github.com/googleapis/googleapis/blob/master/google/bytestream/bytestream.proto
//
// #### Writing LogStreams
//
// LogStreams are written to via the Byte Stream API's `Write` RPC. Bytes
// written to LogStreams are expected to be committed and available for reading
// within a reasonable period of time (implementation-defined). Committed bytes
// to a LogStream cannot be overwritten, and finalized LogStreams - indicated by
// setting `finish_write` field in the final WriteRequest - also cannot be
// appended to.
//
// When calling the Byte Stream API's `Write` RPC to write LogStreams, writers
// must pass the `write_resource_name` of a LogStream as
// `ByteStream.WriteRequest.resource_name` rather than the LogStream's `name`.
// Separate resource names for reading and writing allows for broadcasting the
// read resource name widely while simultaneously ensuring that only writer(s)
// with knowledge of the write resource name may have written bytes to the
// LogStream.
//
// #### Reading LogStreams
//
// Use the Byte Stream API's `Read` RPC to read LogStreams. When reading
// finalized LogStreams the server will stream all contents of the LogStream
// starting at `ByteStream.ReadRequest.read_offset`.
//
// When reading unfinalized LogStreams the server must keep the streaming
// `ByteStream.Read` RPC open and send `ByteStream.ReadResponse` messages as
// more bytes become available or the LogStream is finalized.
//
// #### Example Multi-Party Read/Write Flow
//
// 1. LogStream Writer calls `CreateLogStream`
// 2. LogStream Writer publishes `LogStream.name`
// 3. LogStream Writer calls `ByteStream.Write` with
//    `LogStream.write_resource_name` as
//    `ByteStream.WriteRequest.resource_name`,
//    `ByteStream.WriteRequest.finish_write`=false.
// 4. LogStream Reader(s) call `ByteStream.Read` with the published
//    `LogStream.name` as `ByteStream.ReadRequest.resource_name`.
// 5. LogStream Service streams all committed bytes to LogStream Reader(s),
//    leave the stream open.
// 6. LogStream Writer calls `ByteStream.Write` with
//    `LogStream.write_resource_name` as
//    `ByteStream.WriteRequest.resource_name`,
//    `ByteStream.WriteRequest.finish_write`=true.
// 7. LogStream Service streams all remaining bytes to LogStream Reader(s),
//    terminates the stream.
class LogStreamService final {
 public:
  static constexpr char const* service_full_name() {
    return "build.bazel.remote.logstream.v1.LogStreamService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Create a LogStream which may be written to.
    //
    // The returned LogStream resource name will include a `write_resource_name`
    // which is the resource to use when writing to the LogStream.
    // Callers of CreateLogStream are expected to NOT publish the
    // `write_resource_name`.
    virtual ::grpc::Status CreateLogStream(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest& request, ::build::bazel::remote::logstream::v1::LogStream* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::logstream::v1::LogStream>> AsyncCreateLogStream(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::logstream::v1::LogStream>>(AsyncCreateLogStreamRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::logstream::v1::LogStream>> PrepareAsyncCreateLogStream(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::logstream::v1::LogStream>>(PrepareAsyncCreateLogStreamRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Create a LogStream which may be written to.
      //
      // The returned LogStream resource name will include a `write_resource_name`
      // which is the resource to use when writing to the LogStream.
      // Callers of CreateLogStream are expected to NOT publish the
      // `write_resource_name`.
      virtual void CreateLogStream(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* request, ::build::bazel::remote::logstream::v1::LogStream* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateLogStream(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* request, ::build::bazel::remote::logstream::v1::LogStream* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::logstream::v1::LogStream>* AsyncCreateLogStreamRaw(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::build::bazel::remote::logstream::v1::LogStream>* PrepareAsyncCreateLogStreamRaw(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateLogStream(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest& request, ::build::bazel::remote::logstream::v1::LogStream* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::logstream::v1::LogStream>> AsyncCreateLogStream(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::logstream::v1::LogStream>>(AsyncCreateLogStreamRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::logstream::v1::LogStream>> PrepareAsyncCreateLogStream(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::logstream::v1::LogStream>>(PrepareAsyncCreateLogStreamRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateLogStream(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* request, ::build::bazel::remote::logstream::v1::LogStream* response, std::function<void(::grpc::Status)>) override;
      void CreateLogStream(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* request, ::build::bazel::remote::logstream::v1::LogStream* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::logstream::v1::LogStream>* AsyncCreateLogStreamRaw(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::build::bazel::remote::logstream::v1::LogStream>* PrepareAsyncCreateLogStreamRaw(::grpc::ClientContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateLogStream_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Create a LogStream which may be written to.
    //
    // The returned LogStream resource name will include a `write_resource_name`
    // which is the resource to use when writing to the LogStream.
    // Callers of CreateLogStream are expected to NOT publish the
    // `write_resource_name`.
    virtual ::grpc::Status CreateLogStream(::grpc::ServerContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* request, ::build::bazel::remote::logstream::v1::LogStream* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateLogStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateLogStream() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateLogStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLogStream(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* /*request*/, ::build::bazel::remote::logstream::v1::LogStream* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateLogStream(::grpc::ServerContext* context, ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* request, ::grpc::ServerAsyncResponseWriter< ::build::bazel::remote::logstream::v1::LogStream>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateLogStream<Service > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateLogStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateLogStream() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::build::bazel::remote::logstream::v1::CreateLogStreamRequest, ::build::bazel::remote::logstream::v1::LogStream>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* request, ::build::bazel::remote::logstream::v1::LogStream* response) { return this->CreateLogStream(context, request, response); }));}
    void SetMessageAllocatorFor_CreateLogStream(
        ::grpc::MessageAllocator< ::build::bazel::remote::logstream::v1::CreateLogStreamRequest, ::build::bazel::remote::logstream::v1::LogStream>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::build::bazel::remote::logstream::v1::CreateLogStreamRequest, ::build::bazel::remote::logstream::v1::LogStream>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateLogStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLogStream(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* /*request*/, ::build::bazel::remote::logstream::v1::LogStream* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateLogStream(
      ::grpc::CallbackServerContext* /*context*/, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* /*request*/, ::build::bazel::remote::logstream::v1::LogStream* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateLogStream<Service > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateLogStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateLogStream() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateLogStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLogStream(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* /*request*/, ::build::bazel::remote::logstream::v1::LogStream* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateLogStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateLogStream() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateLogStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLogStream(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* /*request*/, ::build::bazel::remote::logstream::v1::LogStream* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateLogStream(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateLogStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateLogStream() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateLogStream(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateLogStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLogStream(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* /*request*/, ::build::bazel::remote::logstream::v1::LogStream* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateLogStream(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateLogStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateLogStream() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::build::bazel::remote::logstream::v1::CreateLogStreamRequest, ::build::bazel::remote::logstream::v1::LogStream>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::build::bazel::remote::logstream::v1::CreateLogStreamRequest, ::build::bazel::remote::logstream::v1::LogStream>* streamer) {
                       return this->StreamedCreateLogStream(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateLogStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateLogStream(::grpc::ServerContext* /*context*/, const ::build::bazel::remote::logstream::v1::CreateLogStreamRequest* /*request*/, ::build::bazel::remote::logstream::v1::LogStream* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateLogStream(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::build::bazel::remote::logstream::v1::CreateLogStreamRequest,::build::bazel::remote::logstream::v1::LogStream>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateLogStream<Service > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateLogStream<Service > StreamedService;
};

}  // namespace v1
}  // namespace logstream
}  // namespace remote
}  // namespace bazel
}  // namespace build


#endif  // GRPC_build_2fbazel_2fremote_2flogstream_2fv1_2fremote_5flogstream_2eproto__INCLUDED
